Index: channels/chan_iax2.c
===================================================================
--- channels/chan_iax2.c	(revision 391551)
+++ channels/chan_iax2.c	(working copy)
@@ -4448,9 +4448,13 @@
 		} else if (!strcasecmp(tmp->name, "regseconds")) {
 			ast_get_time_t(tmp->value, &regseconds, 0, NULL);
 		} else if (!strcasecmp(tmp->name, "ipaddr")) {
-			if (!ast_sockaddr_parse(&peer->addr, tmp->value, PARSE_PORT_IGNORE)) {
+			int setport = ast_sockaddr_port(&peer->addr);
+			if (!ast_sockaddr_parse(&peer->addr, tmp->value, PARSE_PORT_FORBID)) {
 				ast_log(LOG_WARNING, "Failed to parse sockaddr '%s' for ipaddr of realtime peer '%s'\n", tmp->value, tmp->name);
 			}
+			if (setport) {
+				ast_sockaddr_set_port(&peer->addr, setport);
+			}
 		} else if (!strcasecmp(tmp->name, "port")) {
 			ast_sockaddr_set_port(&peer->addr, atoi(tmp->value));
 		} else if (!strcasecmp(tmp->name, "host")) {
@@ -4461,9 +4465,6 @@
 
 	ast_variables_destroy(var);
 
-	if (!peer)
-		return NULL;
-
 	if (ast_test_flag64((&globalflags), IAX_RTCACHEFRIENDS)) {
 		ast_copy_flags64(peer, &globalflags, IAX_RTAUTOCLEAR|IAX_RTCACHEFRIENDS);
 		if (ast_test_flag64(peer, IAX_RTAUTOCLEAR)) {
